/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Michael Fiedler     - initial API and implementation for Bugzilla adapter
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse
 *     .org/bugs/show_bug.cgi?id=422448)
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/
package se.kth.md.aide.oslc.ccm;

import com.google.common.base.Strings;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.Optional;
import java.util.stream.Stream;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.core.UriInfo;
import org.eclipse.lyo.oslc4j.core.annotation.OslcQueryCapability;
import org.eclipse.lyo.oslc4j.core.annotation.OslcService;
import org.eclipse.lyo.oslc4j.core.model.Compact;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.OslcMediaType;
import org.eclipse.lyo.oslc4j.core.model.Preview;
import org.eclipse.lyo.oslc4j.core.model.ServiceProvider;
import org.eclipse.lyo.tools.store.ModelUnmarshallingException;
import org.eclipse.lyo.tools.store.StoreAccessException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@OslcService(ConfigurationManagementConstants.CONFIGURATION_MANAGEMENT_DOMAIN)
@Path("ccm-services/{serviceProviderId}/resources")
public class VersionResourceService {
  public static final String JSP_ROOT = "/se/kth/md/aide/oslc/ccm";
  private final static Logger log = LoggerFactory.getLogger(VersionResourceService.class);
  @Context
  private HttpServletRequest httpServletRequest;
  @Context
  private HttpServletResponse httpServletResponse;
  @Context
  private UriInfo uriInfo;

  public VersionResourceService() {
    super();
    checkConfiguration();
  }

  @OslcQueryCapability(title = "QueryCapabilityVR", label = "QueryCapabilityVersions",
                       resourceShape = OslcConstants.PATH_RESOURCE_SHAPES + "/" +
                           ConfigurationManagementConstants.PATH_VERSIONRESOURCE,
                       resourceTypes = {ConfigurationManagementConstants.TYPE_VERSIONRESOURCE},
                       usages = {OslcConstants.OSLC_USAGE_DEFAULT})
  @GET
  @Path("versions")
  @Produces(
      {OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType
          .APPLICATION_JSON})
  public VersionResource[] queryVersionResources(
      @PathParam("serviceProviderId") final String serviceProviderId,
      @QueryParam("oslc.where") final String where, @QueryParam("page") final String pageString,
      @QueryParam("limit") final String limitString) throws IOException, ServletException {
    int page = 0;
    int limit = 20;
    if (null != pageString) {
      page = Integer.parseInt(pageString);
    }
    if (null != limitString) {
      limit = Integer.parseInt(limitString);
    }

    final List<VersionResource> resources = queryVersionResources(httpServletRequest,
        serviceProviderId, where, page, limit);
    return resources.toArray(new VersionResource[resources.size()]);
  }

  @GET
  @Path("versions")
  @Produces({MediaType.TEXT_HTML})
  public Response queryVersionResourcesAsHtml(
      @PathParam("serviceProviderId") final String serviceProviderId,
      @QueryParam("oslc.where") final String where, @QueryParam("page") final String pageString,
      @QueryParam("limit") final String limitString) throws ServletException, IOException {
    int page = 0;
    int limit = 20;
    if (null != pageString) {
      page = Integer.parseInt(pageString);
    }
    if (null != limitString) {
      limit = Integer.parseInt(limitString);
    }

    final List<VersionResource> resources = queryVersionResources(httpServletRequest,
        serviceProviderId, where, page, limit);

    if (resources != null) {
      httpServletRequest.setAttribute("resources", resources);

      httpServletRequest.setAttribute("queryUri", getCurrentPathString() + "?oslc.paging=true");
      if (resources.size() > limit) {
        resources.remove(resources.size() - 1);
        httpServletRequest.setAttribute("nextPageUri",
            getCurrentPathString() + "?oslc.paging=true&amp;page=" + (page + 1));
      }
      RequestDispatcher rd = httpServletRequest.getRequestDispatcher(
          JSP_ROOT + "/versionresourcescollection.jsp");
      rd.forward(httpServletRequest, httpServletResponse);
    }

    throw new WebApplicationException(Status.NOT_FOUND);
  }

  @GET
  @Path("versionResources/{resourceId}/{versionId}")
  @Produces(
      {OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType
          .APPLICATION_JSON})
  public VersionResource getVersionResource(
      @PathParam("serviceProviderId") final String serviceProviderId,
      @PathParam("resourceId") final String resourceId,
      @PathParam("versionId") final String versionId)
      throws IOException, ServletException, URISyntaxException {

    final VersionResource aVersionResource = getVersionResource(httpServletRequest,
        serviceProviderId, resourceId, versionId);

    if (aVersionResource != null) {

      return aVersionResource;
    }

    throw new WebApplicationException(Status.NOT_FOUND);
  }

  @GET
  @Path("versionResources/{resourceId}/{versionId}")
  @Produces({OslcMediaType.APPLICATION_X_OSLC_COMPACT_XML})
  public Compact getVersionResourceCompact(
      @PathParam("serviceProviderId") final String serviceProviderId,
      @PathParam("resourceId") final String resourceId,
      @PathParam("versionId") final String versionId)
      throws ServletException, IOException, URISyntaxException {

    final VersionResource aVersionResource = getVersionResource(httpServletRequest,
        serviceProviderId, resourceId, versionId);

    if (aVersionResource != null) {
      final Compact compact = new Compact();

      compact.setAbout(aVersionResource.getAbout());

      //String iconUri = "https://landfill.bugzilla.org/bugzilla-4.4-branch/images/favicon.ico";
      //compact.setIcon(new URI(iconUri));

      //Create and set attributes for OSLC preview resource

      final Preview smallPreview = new Preview();
      smallPreview.setHintHeight("11em");
      smallPreview.setHintWidth("45em");
      smallPreview.setDocument(new URI(compact.getAbout().toString() + "/smallPreview"));
      compact.setSmallPreview(smallPreview);

      //Use the HTML representation of a change request as the large preview as well

      final Preview largePreview = new Preview();
      largePreview.setHintHeight("20em");
      largePreview.setHintWidth("45em");
      largePreview.setDocument(compact.getAbout());
      compact.setLargePreview(largePreview);

      return compact;
    }

    throw new WebApplicationException(Status.NOT_FOUND);
  }

  @GET
  @Path("versionResources/{resourceId}/{versionId}/smallPreview")
  @Produces({MediaType.TEXT_HTML})
  public void getVersionResourcesmallPreview(
      @PathParam("serviceProviderId") final String serviceProviderId,
      @PathParam("resourceId") final String resourceId,
      @PathParam("versionId") final String versionId)
      throws ServletException, IOException, URISyntaxException {

    final VersionResource aVersionResource = getVersionResource(httpServletRequest,
        serviceProviderId, resourceId, versionId);

    if (aVersionResource != null) {
      httpServletRequest.setAttribute("aVersionResource", aVersionResource);

      RequestDispatcher rd = httpServletRequest.getRequestDispatcher(
          JSP_ROOT + "/versionresource_preview_small.jsp");
      rd.forward(httpServletRequest, httpServletResponse);
      return;
    }

    throw new WebApplicationException(Status.NOT_FOUND);
  }

  @GET
  @Path("versionResources/{resourceId}/{versionId}")
  @Produces({MediaType.TEXT_HTML})
  public Response getVersionResourceAsHtml(
      @PathParam("serviceProviderId") final String serviceProviderId,
      @PathParam("resourceId") final String resourceId,
      @PathParam("versionId") final String versionId)
      throws ServletException, IOException, URISyntaxException {

    final VersionResource aVersionResource = getVersionResource(httpServletRequest,
        serviceProviderId, resourceId, versionId);

    if (aVersionResource != null) {
      httpServletRequest.setAttribute("aVersionResource", aVersionResource);

      RequestDispatcher rd = httpServletRequest.getRequestDispatcher(
          JSP_ROOT + "/versionresource.jsp");
      rd.forward(httpServletRequest, httpServletResponse);
    }

    throw new WebApplicationException(Status.NOT_FOUND);
  }

  private void checkConfiguration() {
    if (Objects.isNull(VersionServiceConfiguration.getKeyProvider())) {
      log.error("Key Provider must be configured");
    }
    if (Strings.isNullOrEmpty(VersionServiceConfiguration.getServicesBase())) {
      log.error("Services Base URI must be configured");
    }
    if (Objects.isNull(VersionServiceConfiguration.getStore())) {
      log.error("Store must be configured");
    }
  }

  private String getCurrentPathString() {
    return String.format("%s/%s", VersionServiceConfiguration.getServicesBase(), uriInfo.getPath());
//        return uriInfo.getAbsolutePath().toString();
  }

  static List<VersionResource> queryVersionResources(HttpServletRequest httpServletRequest,
      final String serviceProviderId, String where, int page, int limit) {
    List<VersionResource> resources = null;

    // Start of user code queryVersionResources
    try {
      Optional<ServiceProvider> serviceProvider = VersionServiceConfiguration
          .findServiceProviderById(
          serviceProviderId);
      URI versionResourceGraphName = VersionServiceConfiguration.getVersionResourceGraphName(
          serviceProvider.get());
      resources = VersionServiceConfiguration.getStore().getResources(versionResourceGraphName,
          VersionResource.class);
      resources = slicePaging(resources, page, limit);
    } catch (StoreAccessException | ModelUnmarshallingException e) {
      log.warn("Error while fetching VersionResources: {}", e);
    }
    // End of user code
    return resources;
  }

  // TODO /Andrew 2017-04-03: refactor into the library or, better, commit to Lyo
  private static <T> List<T> slicePaging(List<T> resources, int page, int limit) {
    if (limit <= 0) {
      return resources;
    }
    int fromIndex = page * limit;
    // override due to a bug in service that determines paging flag,
    // it removes the last element if there are more than 'limit' records
    int limitIndex = fromIndex + limit + 1; // TODO: 2016-12-26 remove +1 workaround
    int toIndex = Math.min(limitIndex, resources.size());
    log.trace("Creating a slice [{},{}] on a list of {} elements", fromIndex, toIndex,
        resources.size());
    // because service calls .remove() method that is not defined on some immutable
    // implementations
    // TODO: 2016-12-25 fix in the generator to call subList(0, size-1)
    return new ArrayList<>(resources.subList(fromIndex, toIndex));
  }

  static VersionResource getVersionResource(HttpServletRequest httpServletRequest,
      final String serviceProviderId, final String resourceId, final String versionId) {
    VersionResource aResource = null;

    // Start of user code getVersionResource
    List<VersionResource> latestResources = queryVersionResources(httpServletRequest,
        serviceProviderId, null, -1, -1);

    Stream<VersionResource> resourceStream = latestResources.stream()
        .filter(vr -> resourceId.equals(vr.getIdentifier()) && versionId.equals(vr.getVersionId()));
    aResource = resourceStream.findFirst().orElse(null);
    // End of user code
    return aResource;
  }

}
